import 'package:feed_plugin/models/user_model.dart';

class StoryModel {
  static final StoryModel storyModel = new StoryModel();
  int id;
  UserModel user;
  DateTime createdAt;
  String attachedUrl;
  String text;
  bool isArchive;

  StoryModel({
    this.id,
    this.user,
    this.createdAt,
    this.attachedUrl,
    this.text,
    this.isArchive,
  });

  factory StoryModel.fromJson(Map<String, dynamic> json) {
    UserModel user = json["user"] != null
        ? UserModel.fromJson(json["user"]):null;

    return new StoryModel(
      id: json['id'],
      user: user,
      createdAt: DateTime.parse(json['createdAt'] as String),
      attachedUrl: json['attachedUrl'].toString(),
      text: json['text'].toString(),
      isArchive: json['isArchive'],
    );
  }
}
