// import 'dart:html';

import 'package:feed_plugin/models/poll_option_model.dart';
import 'package:feed_plugin/models/poll_vote_model.dart';
import 'package:feed_plugin/models/post_model.dart';
import 'package:feed_plugin/models/user_model.dart';
import 'package:feed_plugin/repo/feed_repository.dart';
import 'package:feed_plugin/service/http_service.dart';
import 'package:feed_plugin/widgets/media.dart';
import 'package:feed_plugin/widgets/post.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:flutter_screenutil/screenutil_init.dart';
import 'package:url_launcher/url_launcher.dart';

import 'home_page.dart';

class PartnerFeedPage extends StatefulWidget {
  const PartnerFeedPage({
    Key key,
    // @required this.currentPartner,
    @required this.currentUser,
    @required this.saveId,
    @required this.likeId,
    @required this.dislikeId,
    @required this.loc,
    @required this.firstName,
    @required this.media,
    @required this.profileImg,
    @required this.pollOptionsList,
    @required this.pollVotesList,
  }) : super(key: key);
  // final UserModel currentPartner;
  final UserModel currentUser;
  final int saveId;
  final int likeId;
  final int dislikeId;
  final loc;
  final String firstName;
  final String profileImg;
  final media;
  final List<PollOptionModel> pollOptionsList;
  final List<PollVoteModel> pollVotesList;

  @override
  _PartnerFeedPageState createState() => _PartnerFeedPageState();
}

class _PartnerFeedPageState extends State<PartnerFeedPage>
    with SingleTickerProviderStateMixin {
  HttpService httpService;
  FeedRepository feedRepository;
  List<PostModel> postsList = [];
  var _scrollController = ScrollController();
  TabController _controller;
//DB לסדר את זה- כי עכשיו אין את הפרטנר ב
  getPartnerFeedPost() async {
    return null;
    //   await feedRepository
    //       .fetchPostsByUserId(this.widget.currentPartner.id)
    //       .then((myPosts) => setState(
    //             () {
    //               myPosts.sort((a, b) => a.createdAt.compareTo(b.createdAt));
    //               postsList = myPosts.reversed.toList();
    //             },
    //           ));
  }

  @override
  void initState() {
    _controller = new TabController(length: 1, vsync: this);
    httpService = HttpService("gogog");
    feedRepository = FeedRepository(httpService);
    // getPartnerFeedPost();
    _scrollController.addListener(_onScroll);
    super.initState();
  }

  void _onScroll() {
    if (_scrollController.position.pixels ==
        _scrollController.position.maxScrollExtent) {
      getPartnerFeedPost();
    }
  }

  @override
  Widget build(BuildContext context) {
    return Directionality(
      textDirection: TextDirection.ltr,
      child: ScreenUtilInit(
        designSize: Size(375.0, 812.0),
        allowFontScaling: false,
        builder: () =>
            // LayoutBuilder(
            // builder: (_, BoxConstraints constraints) {
            //   return MaterialApp(
            //     home:
            Scaffold(
          backgroundColor: Color(0xffE8ECEF),
          appBar: PreferredSize(
            preferredSize: Size.fromHeight(70.0),
            child: AppBar(
              backgroundColor: Color(0xFF083356),
              leading: Padding(
                padding: EdgeInsets.only(
                  top: ScreenUtil().setWidth(9),
                ),
                child: IconButton(
                  onPressed: () {
                    Navigator.pop(context);
                  },
                  icon: Icon(Icons.arrow_back, color: Colors.white),
                ),
              ),
              title: Padding(
                padding: EdgeInsets.only(
                    right: ScreenUtil().setWidth(50),
                    top: ScreenUtil().setWidth(9)),
                child: Center(
                    child: Text(
                  this.widget.firstName + this.widget.loc.translate(" Feed"),
                  style: TextStyle(color: Colors.white),
                )),
              ),
            ),
          ),
          body: _buildContent(),
        ),
        //     );
        //   },
        // ),
      ),
    );
  }

  _buildContent() {
    return _buildView();
  }

  _buildView() {
    return Directionality(
      textDirection: TextDirection.ltr,
      child: TabBarView(
        controller: _controller,
        children: <Widget>[_buildList(postsList, "Posts")],
      ),
    );
  }

  _buildList(listToShow, type) {
    return Stack(children: [
      RefreshIndicator(
        onRefresh: () {
          return getPartnerFeedPost();
        },
        child: ListView.separated(
          controller: _scrollController,
          cacheExtent: 1,
          itemCount: listToShow.length + 1,
          itemBuilder: (BuildContext context, int index) {
            if (index == 0) {
              return Container(
                color: Color(0xffE8ECEF),
                height: listToShow.length == 0
                    ? ScreenUtil().setHeight(690)
                    : ScreenUtil().setHeight(550),
                child: Column(
                  children: [
                    _buildProfile(),
                    _buildDetails(),
                    _activityButton(),
                    _buildContactInfo(),
                    this.widget.media != null
                        ? MediaPage(
                            whatsapp: this.widget.media.whatsapp,
                            facebook: this.widget.media.facebook,
                            instagram: this.widget.media.instagram,
                            tiktok: this.widget.media.tiktok,
                            twitter: this.widget.media.twitter,
                            youtube: this.widget.media.youtube,
                            linkedin: this.widget.media.linkedin,
                            loc: this.widget.loc,
                          )
                        : Container(),
                    _buildTabBar(),
                    listToShow.length == 0
                        ? Padding(
                            padding: const EdgeInsets.all(10),
                            child: Container(
                              child: Text(
                                widget.loc.translate("No Posts Yet..."),
                                style: TextStyle(
                                  fontSize: ScreenUtil().setWidth(20),
                                  color: Color(0xFF98A9BC),
                                ),
                              ),
                            ),
                          )
                        : Container(),
                  ],
                ),
              );
            }
            PostModel post = listToShow[index - 1];
            List<PollVoteModel> pollVotesListToQuestion = [];
            List<PollOptionModel> pollOptionsListToPost = [];
            if (post.pollQuestion != null) {
              pollVotesListToQuestion = this
                  .widget
                  .pollVotesList
                  .where((p) =>
                      p.pollOption.pollQuestion.id == post.pollQuestion.id)
                  .toList();
              pollOptionsListToPost = widget.pollOptionsList
                  .where((p) => p.pollQuestion.id == post.pollQuestion.id)
                  .toList();
            }
            return FeedPost(
                postData: post,
                likeId: this.widget.likeId,
                dislikeId: this.widget.dislikeId,
                saveId: this.widget.saveId,
                currentUser: this.widget.currentUser,
                images: post.attachedUrl.split("*"),
                commentsLength: 0,
                postsList: null,
                pollOptionsList: pollOptionsListToPost,
                generalPollOptionsList: this.widget.pollOptionsList,
                pollVotesList: pollVotesListToQuestion,
                loc: this.widget.loc);
          },
          separatorBuilder: (BuildContext context, int index) =>
              const Divider(),
        ),
      ),
    ]);
  }

  _buildProfile() {
    return Container(
        color: Colors.white,
        child: Padding(
            padding: EdgeInsets.only(
              left: ScreenUtil().setHeight(17),
              top: ScreenUtil().setHeight(20),
              bottom: ScreenUtil().setHeight(15),
            ),
            child: Row(children: [
              Column(
                children: [
                  Container(
                    margin: EdgeInsets.only(
                      right: ScreenUtil().setWidth(10),
                    ),
                    child: widget.profileImg == null ||
                            widget.profileImg == "null" ||
                            widget.profileImg == ""
                        ? ClipOval(
                            child: Material(
                              color: Color(0xffE8ECEF),
                              child: SizedBox(
                                width: ScreenUtil().setWidth(49),
                                height: ScreenUtil().setHeight(50),
                                child: Center(
                                  child: Text(
                                    widget.firstName != null &&
                                            widget.firstName != ""
                                        ? widget.firstName.substring(0, 1)
                                        : "",
                                    style: TextStyle(
                                      color: Color(0xFF083356),
                                      fontSize: ScreenUtil().setSp(15),
                                    ),
                                  ),
                                ),
                              ),
                            ),
                          )
                        : ClipOval(
                            child: Image.network(
                              widget.profileImg,
                              width: ScreenUtil().setWidth(49),
                              height: ScreenUtil().setHeight(50),
                              fit: BoxFit.cover,
                            ),
                          ),
                  ),
                ],
              ),
              Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Container(
                    width:
                        ScreenUtil().screenWidth - ScreenUtil().setWidth(163),
                    child: Text(
                      this.widget.firstName,
                      textAlign: TextAlign.left,
                      maxLines: 1,
                      style: TextStyle(
                        fontWeight: FontWeight.w500,
                        color: Colors.black,
                        fontSize: ScreenUtil().setSp(17),
                        fontFamily: 'Rubik',
                      ),
                    ),
                  ),
                  Container(
                    width:
                        ScreenUtil().screenWidth - ScreenUtil().setWidth(165),
                    child: Text(
                      "",
                      textAlign: TextAlign.left,
                      maxLines: 1,
                      style: TextStyle(
                        fontWeight: FontWeight.normal,
                        color: Colors.black.withOpacity(0.4),
                        fontSize: ScreenUtil().setSp(15),
                        fontFamily: "Rubik",
                      ),
                    ),
                  ),
                ],
              ),
            ])));
  }

  _buildDetails() {
    return Container(
      color: Colors.white,
      padding: EdgeInsets.only(bottom: ScreenUtil().setHeight(5)),
      child: Row(
        children: [
          Expanded(
            child: FlatButton(
              onPressed: () {
                _scrollController.animateTo(
                    _scrollController.position.maxScrollExtent,
                    duration: Duration(milliseconds: 300),
                    curve: Curves.fastOutSlowIn);
              },
              child: Column(
                children: [
                  Text(
                    postsList.length.toString(),
                    style: TextStyle(fontWeight: FontWeight.bold),
                  ),
                  Text(this.widget.loc.translate("Posts")),
                ],
              ),
            ),
          ),
          Expanded(
              child: Column(
            children: [
              Text(
                "100K",
                style: TextStyle(fontWeight: FontWeight.bold),
              ),
              Text(this.widget.loc.translate("Followers")),
            ],
          )),
          Expanded(
              child: Column(
            children: [
              Text(
                "397",
                style: TextStyle(fontWeight: FontWeight.bold),
              ),
              Text(this.widget.loc.translate("Following")),
            ],
          ))
        ],
      ),
    );
  }

  _activityButton() {
    return Container(
      margin: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
      color: Colors.white,
      height: ScreenUtil().setHeight(80),
      alignment: Alignment.center,
      child: SizedBox(
        height: ScreenUtil().setHeight(40),
        width: ScreenUtil().setHeight(345),
        child: Container(
          decoration: ShapeDecoration(
              color: Colors.white,
              shape: RoundedRectangleBorder(
                side: BorderSide(
                    color: Colors.black, width: 1, style: BorderStyle.solid),
                borderRadius: BorderRadius.circular(5),
              )),
          child: FlatButton(
            onPressed: null,
            child: Text(
                this.widget.loc.translate('Follow ') + this.widget.firstName,
                style: TextStyle(color: Colors.black)),
          ),
        ),
      ),
    );
  }

  _buildContactInfo() {
    List val = [];
    List url = [];
    List type = [];
    if (this.widget.media.phoneNumber != null) {
      val.add(this.widget.loc.translate("Our Phone number:"));
      url.add(this.widget.media.phoneNumber);
      type.add("tel:");
    }
    if (this.widget.media.website != null) {
      val.add(this.widget.loc.translate("Our website:"));
      url.add(this.widget.media.website);
      if (widget.media.website.toString().substring(0, 8).toLowerCase() ==
              "https://" ||
          widget.media.website.toString().substring(0, 8).toLowerCase() ==
              "http://") {
        type.add("");
      } else {
        type.add("https://");
      }
    }
    if (this.widget.media.email != null) {
      val.add(this.widget.loc.translate("Our email:"));
      url.add(this.widget.media.email);
      type.add("mailto:");
    }

    List<Widget> rows = [];
    for (var i = 0; i < val.length; i++) {
      var R = Row(children: [
        Expanded(
          child: Text(this.widget.loc.translate(val[i]),
              style: TextStyle(
                fontSize: ScreenUtil().setSp(16),
                fontFamily: "Rubik",
              )),
        ),
        Expanded(
            child: TextButton(
                onPressed: () => launch(type[i] + url[i]),
                child: Container(
                  alignment: Alignment.centerRight,
                  child: Text(url[i],
                      style: TextStyle(
                        fontSize: ScreenUtil().setSp(16),
                        fontFamily: "Rubik",
                      )),
                )))
      ]);
      rows.add(R);
    }
    return Container(
      margin: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
      color: Colors.white,
      height: val.length == 3
          ? ScreenUtil().setHeight(170)
          : val.length == 2
              ? ScreenUtil().setHeight(100)
              : val.length == 1
                  ? ScreenUtil().setHeight(50)
                  : ScreenUtil().setHeight(0),
      padding: EdgeInsets.only(
          left: ScreenUtil().setHeight(10), right: ScreenUtil().setHeight(10)),
      child: ListView(
        physics: const NeverScrollableScrollPhysics(),
        children: rows,
      ),
    );
  }

  _buildTabBar() {
    return Row(children: [
      Expanded(
          child: Column(children: <Widget>[
        Container(
            color: Colors.white,
            margin: EdgeInsets.only(top: ScreenUtil().setHeight(7)),
            height: ScreenUtil().setHeight(50),
            child: new TabBar(
              labelColor: Color(0xFFE083356),
              unselectedLabelColor: Color(0xFF083356),
              labelStyle: TextStyle(fontWeight: FontWeight.bold),
              unselectedLabelStyle: TextStyle(fontWeight: FontWeight.normal),
              indicatorColor: Color(0xFFE083356),
              indicatorWeight: 5.0,
              controller: _controller,
              tabs: [
                Tab(text: this.widget.loc.translate("Posts")),
              ],
            )),
        Container(
          height: ScreenUtil().setHeight(5),
          // margin: EdgeInsets.only(bottom: ScreenUtil().setHeight(5)),
          color: Colors.white,
        ),
      ]))
    ]);
  }
}
