import 'package:feed_plugin/models/poll_option_model.dart';
import 'package:feed_plugin/models/poll_vote_model.dart';
import 'package:feed_plugin/models/post_model.dart';
import 'package:feed_plugin/models/user_model.dart';
import 'package:feed_plugin/repo/feed_repository.dart';
import 'package:feed_plugin/service/http_service.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/screen_util.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'widgets/calander/calendar.dart';
import 'package:feed_plugin/pages/user_image_page.dart';
import 'package:feed_plugin/widgets/activities.dart';
import 'package:feed_plugin/widgets/calander/calendar.dart';
import 'package:feed_plugin/widgets/post.dart';

class MyHomePage1 extends StatefulWidget {
  const MyHomePage1({
    Key key,
    @required this.currentUser,
    // @required this.currentPartner,
    @required this.saveId,
    @required this.likeId,
    @required this.dislikeId,
    @required this.postsList1,
    @required this.loc,
    @required this.pollOptionsList,
    @required this.pollVotesList,
  }) : super(key: key);
  final UserModel currentUser;
  // final UserModel currentPartner;
  final int saveId;
  final int likeId;
  final int dislikeId;
  final List<PostModel> postsList1;
  final List<PollOptionModel> pollOptionsList;
  final loc;
  final List<PollVoteModel> pollVotesList;
  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage1> {
  // final CategoriesScroller categoriesScroller = CategoriesScroller();
  ScrollController _scrollController = new ScrollController();
  // ScrollController controller = ScrollController();
  bool closeTopContainer = false;
  double topContainer = 0;
  List<PostModel> postsList = [];
  List<PostModel> favoritePostsList = [];
  TabController _controller;
  bool fixedScroll;
  // Channel _channel;
  HttpService httpService;
  FeedRepository feedRepository;
  List<Widget> itemsData = [];
  getMyFavoriteFeedPost() async {
    List<PostModel> posts = [];
    await feedRepository
        .fetchFavoritePosts(this.widget.currentUser.id, this.widget.saveId)
        .then((value) => {
              value.forEach((e) {
                posts.add(e.post);
              }),
              setState(
                () {
                  favoritePostsList = posts.reversed.toList();
                },
              )
            });
  }

  void getPostsData() {
    List<Widget> listItems = [];
    List<int> ages = [29, 27, 42, 67, 90, 78, 89, 90];
    ages.forEach((int w) {
      listItems.add(Container(
          width: ScreenUtil().screenHeight,
          height: 150,
          margin: const EdgeInsets.symmetric(horizontal: 20, vertical: 10),
          decoration: BoxDecoration(
              borderRadius: BorderRadius.all(Radius.circular(20.0)),
              color: Colors.white,
              boxShadow: [
                BoxShadow(color: Colors.black.withAlpha(100), blurRadius: 10.0),
              ]),
          child: Padding(
            padding: const EdgeInsets.symmetric(horizontal: 20.0, vertical: 10),
            child: Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: <Widget>[
                Text("")
                // ----post----
              ],
            ),
          )));
    });
    setState(() {
      itemsData = listItems;
    });
  }

  @override
  void initState() {
    super.initState();
    getPostsData();
    _scrollController.addListener(() {
      double value = _scrollController.offset / 119;

      setState(() {
        topContainer = value;
        closeTopContainer = _scrollController.offset > 50;
      });
    });
  }

  @override
  Widget build(BuildContext context) {
    // final Size size = MediaQuery.of(context).size;
    // final double categoryHeight = size.height * 0.30;
    return SafeArea(
      child: Scaffold(
        backgroundColor: Colors.white,
        appBar: PreferredSize(
            preferredSize: Size.fromHeight(70.0),
            child: AppBar(
                backgroundColor: Color(0xFF083356),
                leading: Padding(
                  padding: EdgeInsets.only(
                    top: ScreenUtil().setWidth(9),
                  ),
                  child: IconButton(
                    onPressed: () {},
                    icon: Icon(Icons.arrow_back, color: Colors.white),
                  ),
                ),
                title: Padding(
                  padding: EdgeInsets.only(
                      right: ScreenUtil().setWidth(50),
                      top: ScreenUtil().setWidth(9)),
                  child: Center(
                      child: Text(
                    "My Feed",
                    style: TextStyle(color: Colors.white),
                  )),
                ),
                actions: <Widget>[
                  Container(
                      child: GestureDetector(
                    onTap: () {
                      Navigator.pop(context);
                    },
                    child: GestureDetector(
                      onTap: () {
                        showDialog(
                            context: context,
                            builder: (BuildContext context) {
                              // var dialogContext = context;
                              return Calendar(
                                loc: null,
                              );
                            });
                        // Navigator.push(
                        //   context,
                        //   MaterialPageRoute(builder: (context) => Calendar()),
                        // );
                      },
                      child: Padding(
                        padding: EdgeInsets.only(
                            right: ScreenUtil().setWidth(10),
                            top: ScreenUtil().setWidth(9)),
                        child: Container(
                            alignment: Alignment.centerRight,
                            child: Icon(Icons.date_range_outlined)),
                      ),
                    ),
                  )),
                ])),
        body: _buildContent(this.widget.currentUser),
      ),
    );
  }

  _buildContent(currentUser) {
    return Directionality(
        textDirection: TextDirection.ltr,
        child: Container(
          child: Stack(
            // child: Column(
            children: [
              // Column(children: [
              Container(
                child: Column(
                  children: [
                    _buildProfile(this.widget.currentUser),
                    _buildDetails(),
                    _activityButton(),
                    _buildTabBar()
                  ],
                ),
              ),
              Padding(
                padding: const EdgeInsets.only(top: 300),
                child: Container(
                  child: _buildTabBarView(),
                ),
              ),
            ],
          ),
        ));
  }

  _buildProfile(currentUser) {
    return Container(
        color: Colors.white,
        child: Padding(
            padding: EdgeInsets.only(
              left: ScreenUtil().setHeight(17),
              top: ScreenUtil().setHeight(20),
              bottom: ScreenUtil().setHeight(15),
            ),
            child: Row(children: [
              Column(
                children: [
                  Container(
                    margin: EdgeInsets.only(
                      right: ScreenUtil().setWidth(10),
                    ),
                    child: currentUser.profileImg == null ||
                            currentUser.profileImg == "" ||
                            currentUser.profileImg == "null"
                        ? ClipOval(
                            child: Material(
                              color: Color(0xffE8ECEF),
                              child: SizedBox(
                                width: ScreenUtil().setWidth(49),
                                height: ScreenUtil().setHeight(50),
                                child: Center(
                                  child: Text(
                                    currentUser.firstName != null &&
                                            currentUser.firstName != "" &&
                                            currentUser.lastName != null &&
                                            currentUser.lastName != ""
                                        ? currentUser.firstName
                                                .substring(0, 1) +
                                            currentUser.lastName.substring(0, 1)
                                        : (currentUser.firstName == null ||
                                                    currentUser.firstName ==
                                                        "") &&
                                                currentUser.lastName != null &&
                                                currentUser.lastName != ""
                                            ? currentUser.lastName
                                                .substring(0, 1)
                                            : (currentUser.lastName == null ||
                                                        currentUser.lastName ==
                                                            "") &&
                                                    currentUser.firstName !=
                                                        null &&
                                                    currentUser.firstName != ""
                                                ? currentUser.firstName
                                                    .substring(0, 1)
                                                : "",
                                    style: TextStyle(
                                      color: Color(0xFF083356),
                                      fontSize: ScreenUtil().setSp(15),
                                    ),
                                  ),
                                ),
                              ),
                            ),
                          )
                        : GestureDetector(
                            onTap: () {
                              Navigator.push(
                                context,
                                MaterialPageRoute(
                                  builder: (context) => UserImagePage(
                                    userData: this.widget.currentUser,
                                  ),
                                ),
                              );
                            },
                            child: ClipOval(
                              child: Image.network(
                                currentUser.profileImg,
                                width: ScreenUtil().setWidth(49),
                                height: ScreenUtil().setHeight(50),
                                fit: BoxFit.cover,
                              ),
                            ),
                          ),
                  ),
                ],
              ),
              Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Container(
                    width:
                        ScreenUtil().screenWidth - ScreenUtil().setWidth(163),
                    child: Text(
                      currentUser.lastName != null &&
                              currentUser.lastName != "null"
                          ? currentUser.firstName + " " + currentUser.lastName
                          : currentUser.firstName,
                      textAlign: TextAlign.left,
                      maxLines: 1,
                      style: TextStyle(
                        fontWeight: FontWeight.w500,
                        color: Colors.black,
                        fontSize: ScreenUtil().setSp(17),
                        fontFamily: 'Rubik',
                      ),
                    ),
                  ),
                  Container(
                    child: Text(
                      currentUser.about,
                      textAlign: TextAlign.left,
                      maxLines: 1,
                      style: TextStyle(
                        fontWeight: FontWeight.normal,
                        color: Colors.black.withOpacity(0.4),
                        fontSize: ScreenUtil().setSp(15),
                        fontFamily: "Rubik",
                      ),
                    ),
                  ),
                ],
              ),
            ])));
  }

  _buildDetails() {
    return Container(
      color: Colors.white,
      padding: EdgeInsets.only(bottom: ScreenUtil().setHeight(5)),
      child: Row(
        children: [
          Expanded(
              child: FlatButton(
                  onPressed: () {
                    print("aa");
                  },
                  child: Column(
                    children: [
                      Text(
                        postsList.length.toString(),
                        style: TextStyle(fontWeight: FontWeight.bold),
                      ),
                      Text(this.widget.loc.translate("Posts")),
                    ],
                  ))),
          Expanded(
            child: Column(
              children: [
                Text(
                  "101K",
                  style: TextStyle(fontWeight: FontWeight.bold),
                ),
                Text(this.widget.loc.translate("Followers")),
              ],
            ),
          ),
          Expanded(
            child: Column(
              children: [
                Text(
                  "397",
                  style: TextStyle(fontWeight: FontWeight.bold),
                ),
                Text(this.widget.loc.translate("Following")),
              ],
            ),
          )
        ],
      ),
    );
  }

  _activityButton() {
    return Container(
      margin: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
      color: Colors.white,
      height: ScreenUtil().setHeight(80),
      alignment: Alignment.center,
      child: SizedBox(
        height: ScreenUtil().setHeight(40),
        width: ScreenUtil().setHeight(345),
        child: Container(
          decoration: ShapeDecoration(
              color: Colors.white,
              shape: RoundedRectangleBorder(
                side: BorderSide(
                    color: Colors.black, width: 1, style: BorderStyle.solid),
                borderRadius: BorderRadius.circular(5),
              )),
          child: FlatButton(
            onPressed: () {
              Navigator.push(
                context,
                MaterialPageRoute(
                    builder: (context) =>
                        BusinessProfilePage(loc: this.widget.loc)),
              );
            },
            child: Text(this.widget.loc.translate('View all activities'),
                style: TextStyle(color: Colors.black)),
          ),
        ),
      ),
    );
  }

  _buildTabBar() {
    return Row(
      children: [
        Expanded(
          child: Column(
            children: <Widget>[
              Container(
                decoration: BoxDecoration(
                  border: Border(
                    bottom: BorderSide(
                      width: ScreenUtil().setHeight(10),
                      color: Color(0xffE8ECEF),
                    ),
                  ),
                ),
              ),
              Container(
                padding: EdgeInsets.only(
                  bottom: ScreenUtil().setHeight(7),
                ),
                color: Color(0xffE8ECEF),
                child: Container(
                  color: Colors.white,
                  child: new TabBar(
                    labelColor: Color(0xFFE083356),
                    unselectedLabelColor: Color(0xFF083356),
                    labelStyle: TextStyle(
                        fontWeight: FontWeight.bold,
                        fontSize: ScreenUtil().setWidth(13)),
                    unselectedLabelStyle: TextStyle(
                        fontWeight: FontWeight.normal,
                        fontSize: ScreenUtil().setWidth(13)),
                    indicatorColor: Color(0xFFE083356),
                    indicatorWeight: 5.0,
                    controller: _controller,
                    tabs: [
                      Tab(
                        text: this.widget.loc.translate("Posts"),
                      ),
                      Tab(text: this.widget.loc.translate("Favorite")),
                    ],
                  ),
                ),
              ),
              Container(
                color: Colors.white,
              ),
            ],
          ),
        ),
      ],
    );
  }

  _buildTabBarView() {
    return TabBarView(
      controller: _controller,
      children: <Widget>[
        _buildList(postsList, "Posts"),
        _buildList(favoritePostsList, "Favorite"),
      ],
    );
  }

  _buildList(listToShow, type) {
    return RefreshIndicator(
      onRefresh: () {
        return getMyFavoriteFeedPost()();
      },
      child: ListView.builder(
        shrinkWrap: true,
        cacheExtent: 1,
        itemCount: listToShow.length + 1,
        itemBuilder: (BuildContext context, int index) {
          if (index == 0) {
            return listToShow.length == 0
                ? Container(
                    color: Colors.pink,
                    child: Text(
                      this.widget.loc.translate("No ") +
                          this.widget.loc.translate(type) +
                          this.widget.loc.translate(" yet..."),
                      textAlign: TextAlign.center,
                      style: TextStyle(
                          fontSize: ScreenUtil().setWidth(20),
                          color: Color(0xFF98A9BC)),
                    ),
                  )
                : Container();
          }

          PostModel post = listToShow[index - 1];
          List<PollVoteModel> pollVotesListToQuestion = [];
          List<PollOptionModel> pollOptionsListToPost = [];
          if (post.pollQuestion != null) {
            pollOptionsListToPost = [];
            pollOptionsListToPost = widget.pollOptionsList
                .where((p) => p.pollQuestion.id == post.pollQuestion.id)
                .toList();
            pollVotesListToQuestion = [];
            pollVotesListToQuestion = this
                .widget
                .pollVotesList
                .where(
                    (p) => p.pollOption.pollQuestion.id == post.pollQuestion.id)
                .toList();
          }
          return Container(
            padding: EdgeInsets.only(bottom: ScreenUtil().setHeight(4)),
            color: Color(0xffE8ECEF),
            child: FeedPost(
                key: Key("F" + post.id.toString()),
                postData: post,
                likeId: this.widget.likeId,
                dislikeId: this.widget.dislikeId,
                saveId: this.widget.saveId,
                currentUser: this.widget.currentUser,
                images: post.attachedUrl.split("*"),
                commentsLength: 0,
                postsList: postsList,
                pollOptionsList: pollOptionsListToPost,
                generalPollOptionsList: this.widget.pollOptionsList,
                pollVotesList: pollVotesListToQuestion,
                loc: this.widget.loc),
          );
        },
      ),
    );
  }
}
// //AppBar אחרי ה
// class CategoriesScroller extends StatelessWidget {
//   const CategoriesScroller();
//   @override
//   Widget build(BuildContext context) {
//     TabController _controller;
//     // final double categoryHeight = MediaQuery.of(context).size.height * 0.30;
//     return SingleChildScrollView(
//       // physics: BouncingScrollPhysics(),
//       // scrollDirection: Axis.horizontal,
//       child: Container(
//         margin: const EdgeInsets.symmetric(vertical: 20, horizontal: 20),
//         child: FittedBox(
//           fit: BoxFit.fill,
//           alignment: Alignment.topCenter,
//           child: Column(
//             children: <Widget>[
//               Container(
//                 width: 150,
//                 // child: _buildProfile(this.currentUser),
//               ),
//               Container(
//                 width: 350,
//                 child: _buildDetails(),
//               ),
//               Container(
//                 width: 350,
//                 margin: EdgeInsets.only(right: 20),
//                 child: _activityButton(),
//               ),
//               //         Container(
//               //             width: 350,
//               //             margin: EdgeInsets.only(right: 20),
//               //             child: new TabBar(
//               //               labelColor: Color(0xFFE083356),
//               //               unselectedLabelColor: Color(0xFF083356),
//               //               labelStyle: TextStyle(
//               //                   fontWeight: FontWeight.bold,
//               //                   fontSize: ScreenUtil().setWidth(13)),
//               //               unselectedLabelStyle: TextStyle(
//               //                   fontWeight: FontWeight.normal,
//               //                   fontSize: ScreenUtil().setWidth(13)),
//               //               indicatorColor: Color(0xFFE083356),
//               //               indicatorWeight: 5.0,
//               //               controller: _controller,
//               //               tabs: [
//               //                 Tab(
//               //                   text: "Posts",
//               //                 ),
//               //                 Tab(text: "Favorite"),
//               //               ],
//               //             )),
//               //         // child: _buildTabBar()),
//             ],
//           ),
//         ),
//       ),
//     );
//   }

//   _buildProfile(currentUser) {
//     return Container(
//         color: Colors.white,
//         child: Padding(
//             padding: EdgeInsets.only(
//               left: ScreenUtil().setHeight(17),
//               top: ScreenUtil().setHeight(20),
//               bottom: ScreenUtil().setHeight(15),
//             ),
//             child: Row(children: [
//               Column(
//                 children: [
//                   Container(
//                     margin: EdgeInsets.only(
//                       right: ScreenUtil().setWidth(10),
//                     ),
//                     child: currentUser.profileImg == null ||
//                             currentUser.profileImg == "" ||
//                             currentUser.profileImg == "null"
//                         ? ClipOval(
//                             child: Material(
//                               color: Color(0xffE8ECEF),
//                               child: SizedBox(
//                                 width: ScreenUtil().setWidth(49),
//                                 height: ScreenUtil().setHeight(50),
//                                 child: Center(
//                                   child: Text(
//                                     currentUser.firstName != null &&
//                                             currentUser.firstName != "" &&
//                                             currentUser.lastName != null &&
//                                             currentUser.lastName != ""
//                                         ? currentUser.firstName
//                                                 .substring(0, 1) +
//                                             currentUser.lastName.substring(0, 1)
//                                         : (currentUser.firstName == null ||
//                                                     currentUser.firstName ==
//                                                         "") &&
//                                                 currentUser.lastName != null &&
//                                                 currentUser.lastName != ""
//                                             ? currentUser.lastName
//                                                 .substring(0, 1)
//                                             : (currentUser.lastName == null ||
//                                                         currentUser.lastName ==
//                                                             "") &&
//                                                     currentUser.firstName !=
//                                                         null &&
//                                                     currentUser.firstName != ""
//                                                 ? currentUser.firstName
//                                                     .substring(0, 1)
//                                                 : "",
//                                     style: TextStyle(
//                                       color: Color(0xFF083356),
//                                       fontSize: ScreenUtil().setSp(15),
//                                     ),
//                                   ),
//                                 ),
//                               ),
//                             ),
//                           )
//                         : GestureDetector(
//                             onTap: () {},
//                             child: ClipOval(
//                               child: Image.network(
//                                 currentUser.profileImg,
//                                 width: ScreenUtil().setWidth(49),
//                                 height: ScreenUtil().setHeight(50),
//                                 fit: BoxFit.cover,
//                               ),
//                             ),
//                           ),
//                   ),
//                 ],
//               ),
//               Column(
//                 crossAxisAlignment: CrossAxisAlignment.start,
//                 children: [
//                   Container(
//                     width:
//                         ScreenUtil().screenWidth - ScreenUtil().setWidth(163),
//                     child: Text(
//                       currentUser.lastName != null &&
//                               currentUser.lastName != "null"
//                           ? currentUser.firstName + " " + currentUser.lastName
//                           : currentUser.firstName,
//                       textAlign: TextAlign.left,
//                       maxLines: 1,
//                       style: TextStyle(
//                         fontWeight: FontWeight.w500,
//                         color: Colors.black,
//                         fontSize: ScreenUtil().setSp(17),
//                         fontFamily: 'Rubik',
//                       ),
//                     ),
//                   ),
//                   Container(
//                     // width:
//                     //     ScreenUtil().screenWidth - ScreenUtil().setWidth(165),
//                     child: Text(
//                       currentUser.about,
//                       textAlign: TextAlign.left,
//                       maxLines: 1,
//                       style: TextStyle(
//                         fontWeight: FontWeight.normal,
//                         color: Colors.black.withOpacity(0.4),
//                         fontSize: ScreenUtil().setSp(15),
//                         fontFamily: "Rubik",
//                       ),
//                     ),
//                   ),
//                 ],
//               ),
//             ])));
//   }

//   _buildDetails() {
//     return Container(
//       color: Colors.white,
//       padding: EdgeInsets.only(bottom: ScreenUtil().setHeight(5)),
//       child: Row(
//         children: [
//           Expanded(
//               child: FlatButton(
//                   onPressed: () {
//                     print("aa");
//                   },
//                   child: Column(
//                     children: [
//                       Text(
//                         "5",
//                         // postsList.length.toString(),
//                         style: TextStyle(fontWeight: FontWeight.bold),
//                       ),
//                       Text("Posts"),
//                     ],
//                   ))),
//           Expanded(
//             child: Column(
//               children: [
//                 Text(
//                   "100K",
//                   style: TextStyle(fontWeight: FontWeight.bold),
//                 ),
//                 Text("Followers"),
//               ],
//             ),
//           ),
//           Expanded(
//             child: Column(
//               children: [
//                 Text(
//                   "397",
//                   style: TextStyle(fontWeight: FontWeight.bold),
//                 ),
//                 Text("Following"),
//               ],
//             ),
//           )
//         ],
//       ),
//     );
//   }

//   _activityButton() {
//     return Container(
//       margin: EdgeInsets.only(top: ScreenUtil().setHeight(2)),
//       color: Colors.white,
//       height: ScreenUtil().setHeight(80),
//       alignment: Alignment.center,
//       child: SizedBox(
//         height: ScreenUtil().setHeight(40),
//         width: ScreenUtil().setHeight(345),
//         child: Container(
//           decoration: ShapeDecoration(
//               color: Colors.white,
//               shape: RoundedRectangleBorder(
//                 side: BorderSide(
//                     color: Colors.black, width: 1, style: BorderStyle.solid),
//                 borderRadius: BorderRadius.circular(5),
//               )),
//           child: FlatButton(
//             onPressed: () {},
//             child: Text('View all activities',
//                 style: TextStyle(color: Colors.black)),
//           ),
//         ),
//       ),
//     );
//   }

//   _buildTabBar() {
//     return Row(
//       children: [
//         Expanded(
//           child: Column(
//             children: <Widget>[
//               Container(
//                 decoration: BoxDecoration(
//                   border: Border(
//                     bottom: BorderSide(
//                       width: ScreenUtil().setHeight(10),
//                       color: Color(0xffE8ECEF),
//                     ),
//                   ),
//                 ),
//               ),
//               Container(
//                 padding: EdgeInsets.only(
//                   bottom: ScreenUtil().setHeight(7),
//                 ),
//                 color: Color(0xffE8ECEF),
//                 // height: ScreenUtil().setHeight(30),
//                 child: Container(
//                   color: Colors.white,
//                   child: new TabBar(
//                     labelColor: Color(0xFFE083356),
//                     unselectedLabelColor: Color(0xFF083356),
//                     labelStyle: TextStyle(
//                         fontWeight: FontWeight.bold,
//                         fontSize: ScreenUtil().setWidth(13)),
//                     unselectedLabelStyle: TextStyle(
//                         fontWeight: FontWeight.normal,
//                         fontSize: ScreenUtil().setWidth(13)),
//                     indicatorColor: Color(0xFFE083356),
//                     indicatorWeight: 5.0,
//                     // controller: _controller,
//                     tabs: [
//                       Tab(
//                         text: "Posts",
//                       ),
//                       Tab(text: "Favorite"),
//                     ],
//                   ),
//                 ),
//               ),
//               Container(
//                 // height: ScreenUtil().setHeight(17),
//                 // margin: EdgeInsets.only(bottom: ScreenUtil().setHeight(2)),
//                 color: Colors.white,
//               ),
//             ],
//           ),
//         ),
//       ],
//     );
//   }
// }
