import 'package:feed_plugin/pages/video&picture.dart';
import 'package:flutter/material.dart';
import 'package:video_player/video_player.dart';

class BasicOverlayWidget extends StatelessWidget {
  final VideoPlayerController controller;
  final String url;

  BasicOverlayWidget({
    Key key,
    @required this.controller,
    @required this.url,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) => GestureDetector(
        behavior: HitTestBehavior.opaque,
        onTap: () => {
          if (controller.value.isPlaying)
            {controller.pause()}
          else
            {
              controller.play(),
              // Navigator.push(
              //   context,
              //   MaterialPageRoute(
              //     builder: (context) => VideoAndPicture(
              //       controller: controller,
              //       image: this.url,
              //       title: "Play",
              //     ),
              //   ),
              // ),
            },

          // controller.value.isPlaying ? controller.pause() : controller.play()
          //controller.seekTo(Duration(seconds:0)),
        },
        child: Stack(
          children: <Widget>[
            buildPlay(),
            Positioned(
              bottom: 0,
              left: 0,
              right: 0,
              child: buildIndicator(),
            ),
          ],
        ),
      );

  Widget buildIndicator() => VideoProgressIndicator(
        controller,
        allowScrubbing: true,
        colors: VideoProgressColors(playedColor: Color(0xFF083356)),
      );

  Widget buildPlay() => controller.value.isPlaying
      ? Container()
      : Container(
          alignment: Alignment.center,
          color: Colors.black26,
          // height: ScreenUtil().screenHeight,
          //  width: ScreenUtil().screenWidth,
          child: Icon(Icons.play_arrow, color: Colors.white, size: 80),
        );
}
